> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Message Template

> Message Template — CometChat documentation.

## Overview

A MessageTemplate provides you with the capability to define and customize both the structure and the behavior of the [MessageBubble](/docs/ui-kit/angular/v4/message-bubble). It acts as a schema or design blueprint for the creation of a variety of [MessageBubble](/docs/ui-kit/angular/v4/message-bubble) components, allowing you to manage the appearance and interactions of [MessageBubble](/docs/ui-kit/angular/v4/message-bubble) within your application effectively and consistently.

### Structure

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/6twnUcGNOB9c0CI0/images/eb70b8aa-message_template_overview_web_screens-60ed5a5c80da81712bdfef843d7e7fd0.png?fit=max&auto=format&n=6twnUcGNOB9c0CI0&q=85&s=a9908f8eed50c71539aaa037996cf7a4" width="3600" height="2400" data-path="images/eb70b8aa-message_template_overview_web_screens-60ed5a5c80da81712bdfef843d7e7fd0.png" />
</Frame>

The MessageBubble structure can typically be broken down into the following views:

1. **Leading view**: This is where the sender's avatar is displayed. It's typically on the left of the MessageBubble for messages from others and on the right for messages from the current user.

2. **Header view**: This displays the sender's name and is especially useful in group chats where multiple users are sending messages.

3. **Reply view**: This view can be used to extend the MessageBubble with additional elements. It's typically placed above the Content view.

4. **Content view**: This is the core of the MessageBubble where the message content (text, images, videos, etc.) is displayed.

5. **Bottom view**: This view can be used to extend the MessageBubble with additional elements, such as link previews or a 'load more' button for long messages. It's typically placed beneath the Content view.

6. **Thread view**: This is where the thread reply icon and reply counts are displayed. It's located below the footer view.

7. **Footer view**: This is where the reactions are displayed. It's located at the bottom of the MessageBubble.

8. **status Info view**: This is where the timestamp of the message and its delivery or read status are displayed. It's located inside the MessageBubble just below the content view.

### Properties

MessageTemplate provides you with methods that allow you to alter various properties of the MessageBubble. These properties include aspects such as the `type` and `category` of a message, the appearance and behavior of the header, content, and footer sections of the message bubble,

1. **type**

   Using `type` you can set the type of CometChatMessage, This will map your MessageTemplate to the corresponding CometChatMessage. You can set the MessageTemplete Type using the following code snippet.

2. **category**

   Using `category` you can set the category of a MessageTemplate. This will create a MessageTemplate with the specified category and link it with a CometChatMessage of the same category.

   Please refer to our guide on [Message Categories](/docs/sdk/javascript/message-structure-and-hierarchy) for a deeper understanding of message categories.

3. **headerView**

   The `headerView` method allows you to assign a custom header view to the MessageBubble. By default, it is configured to display the sender's name.

4. **contentView**

   The `contentView` method allows you to assign a custom content view to the MessageBubble. By default, it displays the [Text Bubble](/docs/ui-kit/angular/v4/text-bubble), [Image Bubble](/docs/ui-kit/angular/v4/image-bubble), [File Bubble](/docs/ui-kit/angular/v4/file-bubble), [Audio Bubble](/docs/ui-kit/angular/v4/audio-bubble), or [Video Bubble](/docs/ui-kit/angular/v4/video-bubble), depending on the message type.

5. **footerView**

   The `footerView` method allows you to assign a custom Footer view to the MessageBubble. By default it shows thr reactions for the message bubble.

6. **bottomView**

   The `bottomView` method allows you to assign a custom Bottom view to the MessageBubble. By defuault is has buttons such as link previews or a 'load more' button for long messages.

7. **bubbleView**

   The `bubbleView` method allows you to assign a custom Bubble view to the MessageBubble. By default, headerView, contentView, statusInfoView and footerView together form a message bubble.

8. **statusInfoView**

   The `statusInfoView` method allows you to assign a custom status info view to the MessageBubble. By default, it displays the receipt and timestamp.

9. **options**

   The `options` lets you set the list of actions that a user can perform on a message. This includes actions like reacting to, editing, or deleting a message.

***

```javascript theme={null}
definedTemplates!: CometChatMessageTemplate[];
  ngOnInit(): void {
   this.definedTemplates = [
     new CometChatMessageTemplate({
      type: CUSTOM_MESSAGE_TYPE,
       category: CometChatUIKitConstants.MessageCategory.custom,
       headerView: ()=> { /*return custom template ref*/},
       contentView: ()=> { /*return custom template ref*/},
       footerView: ()=> { /*return custom template ref*/},
       bottomView: ()=> { /*return custom template ref*/},
       bubbleView: ()=> { /*return custom template ref*/},
       options: //your custom options
    })
   ];
  }
```

***

## Customization

Let's dive into how you can use the [properties](#properties) of MessageTemplate to customize an existing template or add a new one to the [MessageList](/docs/ui-kit/angular/v4/message-list) component.

The First step is to fetch the list of existing templates when you want to modify or add to them. This can be done using the getAllMessageTemplates() method from the DataSource of the CometChatUIKit class.

```
definedTemplates!: CometChatMessageTemplate[];
```

### Existing Templates

You will need to first get the MessageTemplate object for the type of message you want to customize. You will be customizing the TextMessage Bubble here. The code snippet to get the Text MessageTemplate is as follows.

<Tabs>
  <Tab title="TypeScript">
    ```ts theme={null}
    definedTemplates!: CometChatMessageTemplate[];

      ngOnInit(): void {
       this.definedTemplates = [
         new CometChatMessageTemplate({
          type: CUSTOM_MESSAGE_TYPE,
           category: CometChatUIKitConstants.MessageCategory.custom,
           headerView: ()=> { /*return custom template ref*/},
           contentView: ()=> { /*return custom template ref*/},
           footerView: ()=> { /*return custom template ref*/},
           bottomView: ()=> { /*return custom template ref*/},
           bubbleView: ()=> { /*return custom template ref*/},
           options: //your custom options
        })
       ];
      }
    ```
  </Tab>
</Tabs>

You will be using [Messages](/docs/ui-kit/angular/v4/messages#overview) Component for example here so to apply Template to Messages you will need to use `MessageListConfiguration`. This is because the [templates](/docs/ui-kit/angular/v4/message-list#templates) function, which is used to apply the custom templates, belongs to the [MessageList](/docs/ui-kit/angular/v4/message-list) component.

You can apply MessageTempletes to Messages Component using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    ```ts theme={null}

    this.messageListConfiguration = new MessageListConfiguration({
       templates:this.definedTemplates,
    });

     <cometchat-messages
      *ngIf="userObject"
      [user]="userObject"
      [messageListConfiguration]="messageListConfiguration"
      ></cometchat-messages>
    ```
  </Tab>
</Tabs>

***

#### HeaderView

The `headerView` method of MessageTemplate allows you to add custom views to the header of your message bubbles. In the example below, we will add a custom header view of every text message in the MessageList.

**Default**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/lqGH-Bgiq2mgS9m9/images/bfd0876b-message_template_header_view_default_web_screens-9b1184146cd7eece15d2e290cd8b4f09.png?fit=max&auto=format&n=lqGH-Bgiq2mgS9m9&q=85&s=3c71dbd5fdcd41996e792f087d5ca893" width="3600" height="2400" data-path="images/bfd0876b-message_template_header_view_default_web_screens-9b1184146cd7eece15d2e290cd8b4f09.png" />
</Frame>

**Custom**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/_oiGBuX1qG3S8Eo5/images/63b5d52b-message_template_header_view_custom_web_screens-bafaad5ddc9b026dbd5ada89f047b14a.png?fit=max&auto=format&n=_oiGBuX1qG3S8Eo5&q=85&s=c5a1bd43364088a1ec159f36a90b20fd" width="3600" height="2400" data-path="images/63b5d52b-message_template_header_view_custom_web_screens-bafaad5ddc9b026dbd5ada89f047b14a.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { MessageListConfiguration } from '@cometchat/uikit-shared';
    import { CometChatMessageTemplate, CometChatUIKitConstants } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      ngOnInit(): void {
        CometChat.getUser("uid").then((user:CometChat.User)=>{
          this.userObject=user;
        });

       this.messageListConfiguration = new MessageListConfiguration({
          templates:this.definedTemplates,
        });

       this.definedTemplates = [
         new CometChatMessageTemplate({
          type: "text",
          category: CometChatUIKitConstants.MessageCategory.message,
          headerView: () => this.headerView,
        })
       ];
      }
      @ViewChild('headerView', { static: true }) headerView!: TemplateRef<any>;

      public userObject!: CometChat.User;
      definedTemplates!: CometChatMessageTemplate[];
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      public messageListConfiguration!: MessageListConfiguration;

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">

     <cometchat-messages
      *ngIf="userObject"
      [user]="userObject"
      [messageListConfiguration]="messageListConfiguration"
      ></cometchat-messages>

    </div>

    <ng-template #headerView>
        <cometchat-avatar image="custom avatar"></cometchat-avatar>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### Contentview

The `contentview` method of MessageTemplate allows you to add a custom view to the content of your message bubbles. In the example below, we will add a custom layout to the content view of every text message in the MessageList.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/pIKiBC-6hdnqY01x/images/532b9ddc-message_template_content_view_custom_web_screens-f53ef342d2568cc56488c6484b048741.png?fit=max&auto=format&n=pIKiBC-6hdnqY01x&q=85&s=67675bc4cc00ef0dd7a47107fbb101ef" width="3600" height="2400" data-path="images/532b9ddc-message_template_content_view_custom_web_screens-f53ef342d2568cc56488c6484b048741.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { MessageListConfiguration } from '@cometchat/uikit-shared';
    import { CometChatMessageTemplate, CometChatUIKitConstants } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      ngOnInit(): void {
        CometChat.getUser("uid").then((user:CometChat.User)=>{
          this.userObject=user;
        });

       this.messageListConfiguration = new MessageListConfiguration({
          templates:this.definedTemplates,
        });

       this.definedTemplates = [
         new CometChatMessageTemplate({
          type: "nudge",
          category: CometChatUIKitConstants.MessageCategory.custom,
          contentView: ()=>this.customBubbleRef,
        })
       ];
      }
      @ViewChild('customBubbleRef', { static: true }) customBubbleRef!: TemplateRef<any>;


      public userObject!: CometChat.User;
      definedTemplates!: CometChatMessageTemplate[];
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      public messageListConfiguration!: MessageListConfiguration;
      public myCustomIcon = 'custom icon';

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">

     <cometchat-messages
      *ngIf="userObject"
      [user]="userObject"
      [messageListConfiguration]="messageListConfiguration"
      ></cometchat-messages>

    </div>

    <ng-template #customBubbleRef>
      <div [ngStyle]="{'width': '100px', 'height': '100px', 'display': 'flex'}">
        <img [src]="myCustomIcon" alt="gif" />
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### BottomView

The `bottomView` method of MessageTemplate allows you to add a custom button view to your message bubbles. In the example below, we will add a custom bottom view to every text message in the MessageList.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/GrDbzzq1LLfv-sgw/images/861d8201-message_template_bottom_view_custom_web_screens-0ece44f31e48fc158b67327a3bfd047a.png?fit=max&auto=format&n=GrDbzzq1LLfv-sgw&q=85&s=56de7350bf7c1dae35139ee478abd864" width="3600" height="2400" data-path="images/861d8201-message_template_bottom_view_custom_web_screens-0ece44f31e48fc158b67327a3bfd047a.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, TextBubbleStyle } from '@cometchat/chat-uikit-angular';
    import { MessageListConfiguration } from '@cometchat/uikit-shared';
    import { CometChatMessageTemplate, CometChatUIKitConstants } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      ngOnInit(): void {
        CometChat.getUser("uid").then((user:CometChat.User)=>{
          this.userObject=user;
        });

       this.messageListConfiguration = new MessageListConfiguration({
          templates:this.definedTemplates,
        });

       this.definedTemplates = [
         new CometChatMessageTemplate({
          type: "text",
          category: CometChatUIKitConstants.MessageCategory.message,
          bottomView: (message: CometChat.BaseMessage) => {
              this.message = message;
              return this.customBottomView;
          },
        })
       ];
      }
      @ViewChild('customBubbleRef', { static: true }) customBubbleRef!: TemplateRef<any>;


      public userObject!: CometChat.User;
      definedTemplates!: CometChatMessageTemplate[];
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      public messageListConfiguration!: MessageListConfiguration;
      public message!: any;
      bottomViewStyle = new TextBubbleStyle({
        width: "100%",
        height: "20px",
        borderRadius: "8px",
        background: "#e3d7fa",
        border:"2px solid red"
      });

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">

     <cometchat-messages
      *ngIf="userObject"
      [user]="userObject"
      [messageListConfiguration]="messageListConfiguration"
      ></cometchat-messages>

    </div>

    <ng-template #customBottomView>
      <cometchat-text-bubble
      *ngIf="message"
      [text]="message.getText()"
      [textStyle]="bottomViewStyle"
      ></cometchat-text-bubble>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### FooterView

The `footerView` method of MessageTemplate allows you to add a footer view to your message bubbles. In the example below, we will add a custom footer view to every text message in the MessageList.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/qrEt0CwYkpwR_jD-/images/d87ea225-message_template_footer_view_custom_web_screens-eb7bc4c1e190102474bbb42c5bb0b0cc.png?fit=max&auto=format&n=qrEt0CwYkpwR_jD-&q=85&s=7165c66b49b337dc53ce2dbe0a83909d" width="3600" height="2400" data-path="images/d87ea225-message_template_footer_view_custom_web_screens-eb7bc4c1e190102474bbb42c5bb0b0cc.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { MessageListConfiguration } from '@cometchat/uikit-shared';
    import { CometChatMessageTemplate, CometChatUIKitConstants } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      ngOnInit(): void {
        CometChat.getUser("uid").then((user:CometChat.User)=>{
          this.userObject=user;
        });

       this.messageListConfiguration = new MessageListConfiguration({
          templates:this.definedTemplates,
        });

       this.definedTemplates = [
         new CometChatMessageTemplate({
          type: "text",
          category: CometChatUIKitConstants.MessageCategory.message,
          footerView: () => this.footerView,
        })
       ];
      }
      @ViewChild('footerView', { static: true }) footerView!: TemplateRef<any>;

      public userObject!: CometChat.User;
      definedTemplates!: CometChatMessageTemplate[];
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      public messageListConfiguration!: MessageListConfiguration;
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">

     <cometchat-messages
      *ngIf="userObject"
      [user]="userObject"
      [messageListConfiguration]="messageListConfiguration"
      ></cometchat-messages>

    </div>

    <ng-template #footerView>
        <cometchat-avatar image="custom avatar"></cometchat-avatar>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### BubbleView

The `bubbleView` method of MessageTemplate allows you to add a bubble view to your message bubbles. In the example below, we will add a custom bubble view to the text message in the MessageList.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/THlknidvlbNx5AzI/images/ac20e2f6-message_template_bubble_view_custom_web_screens-68f7748d8215acee6ea475b43716d520.png?fit=max&auto=format&n=THlknidvlbNx5AzI&q=85&s=dc0985d4c684c0c2853a1e82db8bc391" width="3600" height="2400" data-path="images/ac20e2f6-message_template_bubble_view_custom_web_screens-68f7748d8215acee6ea475b43716d520.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, TextBubbleStyle } from '@cometchat/chat-uikit-angular';
    import { MessageListConfiguration } from '@cometchat/uikit-shared';
    import { CometChatMessageTemplate, CometChatUIKitConstants } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      ngOnInit(): void {
        CometChat.getUser("uid").then((user:CometChat.User)=>{
          this.userObject=user;
        });

       this.messageListConfiguration = new MessageListConfiguration({
          templates:this.definedTemplates,
        });

       this.definedTemplates = [
         new CometChatMessageTemplate({
          type: "text",
          category: CometChatUIKitConstants.MessageCategory.message,
          bubbleView: () => this.customBubbleView,
        })
       ];
      }
      @ViewChild('customBubbleView', { static: true }) customBubbleView!: TemplateRef<any>;

      public userObject!: CometChat.User;
      definedTemplates!: CometChatMessageTemplate[];
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      textStyle = new TextBubbleStyle({
        width: "100",
        height: "20px",
        borderRadius: "8px",
        background: "#e3d7fa",
      });
      public messageListConfiguration!: MessageListConfiguration;
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">

     <cometchat-messages
      *ngIf="userObject"
      [user]="userObject"
      [messageListConfiguration]="messageListConfiguration"
      ></cometchat-messages>

    </div>

    <ng-template #customBubbleView let-message>
      <cometchat-text-bubble
      [text]="message.getText()"
      [textStyle]="textStyle"
    ></cometchat-text-bubble>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### StatusInfoView

The `statusInfoView` method of MessageTemplate allows you to add a status info view to your message bubbles. In the example below, we will add a custom status info view to every text message in the MessageList.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/avBd8wan4jblx26s/images/26cf560b-message_template_status_info_view_web_screens-39132c39da71b1a77b2a8511a493e994.png?fit=max&auto=format&n=avBd8wan4jblx26s&q=85&s=042559838cbf319af3d08fc6f36c5a8e" width="3600" height="2400" data-path="images/26cf560b-message_template_status_info_view_web_screens-39132c39da71b1a77b2a8511a493e994.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, TextBubbleStyle } from '@cometchat/chat-uikit-angular';
    import { MessageListConfiguration } from '@cometchat/uikit-shared';
    import { CometChatMessageTemplate, CometChatUIKitConstants } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      ngOnInit(): void {
        CometChat.getUser("uid").then((user:CometChat.User)=>{
          this.userObject=user;
        });

       this.messageListConfiguration = new MessageListConfiguration({
          templates:this.definedTemplates,
        });

       this.definedTemplates = [
         new CometChatMessageTemplate({
          type: "text",
          category: CometChatUIKitConstants.MessageCategory.message,
          statusInfoView: (message: CometChat.BaseMessage)=>{
            this.message = message;
            return this.statusInfoView
          },
        })
       ];
      }
      @ViewChild('statusInfoView', { static: true }) statusInfoView!: TemplateRef<any>;

      public userObject!: CometChat.User;
      public message!: any;
      definedTemplates!: CometChatMessageTemplate[];
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      textStyle = new TextBubbleStyle({
        width: "100",
        height: "20px",
        borderRadius: "8px",
        background: "#e3d7fa",
      });
      public messageListConfiguration!: MessageListConfiguration;
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">

     <cometchat-messages
      *ngIf="userObject"
      [user]="userObject"
      [messageListConfiguration]="messageListConfiguration"
      ></cometchat-messages>

    </div>

    <ng-template #statusInfoView>
      <div [ngStyle]="{font:'10px Arial sans-serif',color: '#cccccc',textAlign: 'left',padding: '10px'}"
      *ngIf="message"
      >
      {{message.getDeliveredAt()}}
    </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### Options

The `options` method in the MessageTemplate allows you to customize the options that appear in the action sheet when a message is long-pressed. By default, CometChat UI Kit provides a set of options like "Thread Reply", "Copy" ,"Edit", and "Delete".

However, if you wish to override or modify these options, you can use the `options` method and pass a list of `CometChatMessageOption`. This list of options will replace the default set.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/tI1D0nyKUVcz2LEZ/images/c0a95c4d-message_template_options_web_screens-e1a23fcfe57771de050f09c68757b4f9.png?fit=max&auto=format&n=tI1D0nyKUVcz2LEZ&q=85&s=9ef3f9c5fbca82e7eaffaeeee21b7967" width="3600" height="2400" data-path="images/c0a95c4d-message_template_options_web_screens-e1a23fcfe57771de050f09c68757b4f9.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, TextBubbleStyle, ChatConfigurator } from '@cometchat/chat-uikit-angular';
    import { MessageListConfiguration } from '@cometchat/uikit-shared';
    import { CometChatMessageTemplate, CometChatUIKitConstants, CometChatMessageOption } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      ngOnInit(): void {
        CometChat.getUser("uid").then((user:CometChat.User)=>{
          this.userObject=user;
        });

        this.messageListConfiguration = new MessageListConfiguration({
          templates:this.definedTemplates,
        });

        this.definedTemplates = [
         new CometChatMessageTemplate({
          type: "text",
          category: CometChatUIKitConstants.MessageCategory.message,
          options: (loggedInUser: CometChat.User, message: CometChat.BaseMessage, theme: CometChatTheme, group?: CometChat.Group) => {
            return this.getCustomOptions(loggedInUser, message, theme, group);
          }
        })
       ];
      }
      public userObject!: CometChat.User;
      definedTemplates!: CometChatMessageTemplate[];
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      getCustomOptions(
        loggedInUser: CometChat.User,
        message: CometChat.BaseMessage,
        theme: CometChatTheme,
        group?: CometChat.Group
      ): any {
        const defaultOptions: any = ChatConfigurator.getDataSource().getMessageOptions(
          loggedInUser,
          message,
          theme,
          group
        );
        const myView: any = new CometChatMessageOption({
          id: 'custom id',
          title: 'your custom title for options',
          iconURL: myCustomIcon,
          iconTint: '#7316f5',
          onClick: () => console.log('custom action'),
        });
        defaultOptions.push(myView);
        return defaultOptions;
      }
      public messageListConfiguration!: MessageListConfiguration;
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">

     <cometchat-messages
      *ngIf="userObject"
      [user]="userObject"
      [messageListConfiguration]="messageListConfiguration"
      ></cometchat-messages>

    </div>
    ```
  </Tab>
</Tabs>

### New Templates

You can create an entirely new template for custom messages is one of the powerful features of CometChat's MessageTemplate.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Q-VZaihy61fy3D_G/images/1d4fb617-message_template_new_template_web_screens-b3c8ae39e5c1436dfd58cffe7d19bcd5.png?fit=max&auto=format&n=Q-VZaihy61fy3D_G&q=85&s=7c68c1daa12fcc88563a47c45f5e28e3" width="3600" height="2400" data-path="images/1d4fb617-message_template_new_template_web_screens-b3c8ae39e5c1436dfd58cffe7d19bcd5.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { MessageListConfiguration, MessageComposerConfiguration } from '@cometchat/uikit-shared';
    import { CometChatMessageTemplate, CometChatUIKitConstants } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      ngOnInit(): void {
        CometChat.getUser("uid").then((user:CometChat.User)=>{
          this.userObject=user;
        });
        CometChat.getGroup("guid").then((group: CometChat.Group) => {
          this.groupObject = group;
        });

        this.messageListConfiguration = new MessageListConfiguration({
          templates:this.definedTemplates,
        });
        this.messageComposerConfiguration = new MessageComposerConfiguration({
          auxilaryButtonView:this.auxilaryButtonViewTemplate,
        });

        this.definedTemplates = [
         new CometChatMessageTemplate({
          type: "nudge",
          category: CometChatUIKitConstants.MessageCategory.custom,
          contentView: ()=>this.customBubbleRef,
        })
       ];
      }
      public userObject!: CometChat.User;
      public groupObject!: CometChat.Group;
      definedTemplates!: CometChatMessageTemplate[];
      @ViewChild('customBubbleRef', { static: true }) customBubbleRef!: TemplateRef<any>;
      @ViewChild('auxilaryButtonViewTemplate', { static: true }) auxilaryButtonViewTemplate!: TemplateRef<any>;
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      public messageListConfiguration!: MessageListConfiguration;
      public messageComposerConfiguration !: MessageComposerConfiguration;
      getIconStyle = new IconStyle({
         iconTint:"#9415e8", width: "35px", height: "35px"
      });
      sendNudge(item: CometChat.User | CometChat.Group) {
        if (item instanceof CometChat.User) {
          this.userObject = item
        }
        else {
          this.groupObject = item
        }
        let { receiverId, receiverType } = this.getReceiverDetails();
        let icon = "assets/nudge.gif"
        const customData = {
          nudge_url: icon,
        };
        const customType = "nudge";
        const customMessage: CometChat.CustomMessage = new CometChat.CustomMessage(
          receiverId,
          receiverType,
          customType,
          customData
        );
        CometChatUIKit.sendCustomMessage(customMessage)
      }

      getReceiverDetails() {
        let receiverId!: string;
        let receiverType!: string;
        if (this.userObject && this.userObject.getUid()) {
          receiverId = this.userObject.getUid();
          receiverType = CometChatUIKitConstants.MessageReceiverType.user;
        } else if (this.groupObject && this.groupObject.getGuid()) {
          receiverId = this.groupObject.getGuid();
          receiverType = CometChatUIKitConstants.MessageReceiverType.group;
        }
        return { receiverId: receiverId, receiverType: receiverType };
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">

    <cometchat-messages
      *ngIf="userObject"
      [user]="userObject"
      [messageListConfiguration]="messageListConfiguration"
      [messageComposerConfiguration]="messageComposerConfiguration"
    ></cometchat-messages>

    </div>
    <ng-template #auxilaryButtonViewTemplate let-item let-composerId="composerId">
      <cometchat-icon [name]="title" [URL]="myCustomIcon" [iconStyle]="getIconStyle" (click)="sendNudge(item)"></cometchat-icon>
    </ng-template>
    <ng-template #customBubbleRef>
      <div [ngStyle]="{'width': '100px', 'height': '100px', 'display': 'flex'}">
        <img [src]="myCustomIcon" alt="gif" />
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>


> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Message Template

> Message Template — CometChat documentation.

## Overview

A MessageTemplate provides you with the capability to define and customize both the structure and the behavior of the [MessageBubble](/docs/ui-kit/react/v4/message-bubble). It acts as a schema or design blueprint for the creation of a variety of [MessageBubble](/docs/ui-kit/react/v4/message-bubble) components, allowing you to manage the appearance and interactions of [MessageBubble](/docs/ui-kit/react/v4/message-bubble) within your application effectively and consistently.

### Structure

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/6twnUcGNOB9c0CI0/images/eb70b8aa-message_template_overview_web_screens-60ed5a5c80da81712bdfef843d7e7fd0.png?fit=max&auto=format&n=6twnUcGNOB9c0CI0&q=85&s=a9908f8eed50c71539aaa037996cf7a4" width="3600" height="2400" data-path="images/eb70b8aa-message_template_overview_web_screens-60ed5a5c80da81712bdfef843d7e7fd0.png" />
</Frame>

The MessageBubble structure can typically be broken down into the following views:

1. **Leading view**: This is where the sender's avatar is displayed. It's typically on the left of the MessageBubble for messages from others and on the right for messages from the current user.

2. **Header view**: This displays the sender's name and is especially useful in group chats where multiple users are sending messages.

3. **Reply view**: This view can be used to extend the MessageBubble with additional elements. It's typically placed above the Content view.

4. **Content view**: This is the core of the MessageBubble where the message content (text, images, videos, etc.) is displayed.

5. **Bottom view**: This view can be used to extend the MessageBubble with additional elements, such as link previews or a 'load more' button for long messages. It's typically placed beneath the Content view.

6. **Thread view**: This is where the thread reply icon and reply counts are displayed. It's located below the footer view.

7. **Footer view**: This is where the reactions are displayed. It's located at the bottom of the MessageBubble.

8. **status Info view**: This is where the timestamp of the message and its delivery or read status are displayed. It's located inside the MessageBubble just below the content view.

### Properties

MessageTemplate provides you with methods that allow you to alter various properties of the MessageBubble. These properties include aspects such as the `type` and `category` of a message, the appearance and behavior of the header, content, and footer sections of the message bubble,

1. **type**

   Using `type` you can set the type of CometChatMessage, This will map your MessageTemplate to the corresponding CometChatMessage. You can set the MessageTemplates Type using the following code snippet.

2. **category**

   Using `category` you can set the category of a MessageTemplate. This will create a MessageTemplate with the specified category and link it with a CometChatMessage of the same category.

   Please refer to our guide on [Message Categories](/docs/sdk/javascript/message-structure-and-hierarchy) for a deeper understanding of message categories.

3. **headerView**

   The `headerView` method allows you to assign a custom header view to the MessageBubble. By default, it is configured to display the sender's name.

4. **contentView**

   The `contentView` method allows you to assign a custom content view to the MessageBubble. By default, it displays the [Text Bubble](/docs/ui-kit/react/v4/text-bubble), [Image Bubble](/docs/ui-kit/react/v4/image-bubble), [File Bubble](/docs/ui-kit/react/v4/file-bubble), [Audio Bubble](/docs/ui-kit/react/v4/audio-bubble), or [Video Bubble](/docs/ui-kit/react/v4/video-bubble), depending on the message type.

5. **footerView**

   The `footerView` method allows you to assign a custom Footer view to the MessageBubble. By default it shows thr reactions for the message bubble.

6. **bottomView**

   The `bottomView` method allows you to assign a custom Bottom view to the MessageBubble. By defuault is has buttons such as link previews or a 'load more' button for long messages.

7. **bubbleView**

   The `bubbleView` method allows you to assign a custom Bubble view to the MessageBubble. By default, headerView, contentView, statusInfoView and footerView together form a message bubble.

8. **statusInfoView**

   The `statusInfoView` method allows you to assign a custom status info view to the MessageBubble. By default, it displays the receipt and timestamp.

9. **options**

   The `options` lets you set the list of actions that a user can perform on a message. This includes actions like reacting to, editing, or deleting a message.

***

```javascript theme={null}
   let definedTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
   const CUSTOM_MESSAGE_TYPE = "your custom messagetype"
   let customMessageTemplate = new CometChatMessageTemplate({
       type: CUSTOM_MESSAGE_TYPE,
       category: CometChatUIKitConstants.MessageCategory.custom,
       headerView: //your custom header view
       contentView: //your custom content view
       footerView: //your custom footer view
       bottomView: // your custom bottom view
       bubbleView: // your custom bubble view
       options: //your custom options
   });
   definedTemplates.push(customMessageTemplate);
```

***

## Customization

Let's dive into how you can use the [properties](#properties) of MessageTemplate to customize an existing template or add a new one to the [MessageList](/docs/ui-kit/react/v4/message-list) component.

The First step is to fetch the list of existing templates when you want to modify or add to them. This can be done using the getAllMessageTemplates() method from the DataSource of the CometChatUIKit class.

```javascript theme={null}
let definedTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
```

### Existing Templates

You will need to first get the MessageTemplate object for the type of message you want to customize. You will be customizing the TextMessage Bubble here. The code snippet to get the Text MessageTemplate is as follows.

<Tabs>
  <Tab title="TypeScript">
    ```typescript theme={null}
    import {
      CometChatUIKit,
      CometChatUIKitConstants,
    } from "@cometchat/chat-uikit-react";

    let allTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
    for (let i = 0; i < allTemplates.length; i++) {
      if (allTemplates[i].type === CometChatUIKitConstants.MessageTypes.text) {
        //customize allTemplates[i]
      }
    }
    ```
  </Tab>

  <Tab title="JavaScript">
    ```javascript theme={null}
    import {
      CometChatUIKit,
      CometChatUIKitConstants,
    } from "@cometchat/chat-uikit-react";

    let allTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
    for (let i = 0; i < allTemplates.length; i++) {
      if (allTemplates[i].type === CometChatUIKitConstants.MessageTypes.text) {
        //customize allTemplates[i]
      }
    }
    ```
  </Tab>
</Tabs>

You will be using [Messages](/docs/ui-kit/react/v4/messages#overview) Component for example here so to apply Template to Messages you will need to use `MessageListConfiguration`. This is because the [templates](/docs/ui-kit/react/v4/message-list#templates) function, which is used to apply the custom templates, belongs to the [MessageList](/docs/ui-kit/react/v4/message-list) component.

You can apply MessageTemplatess to Messages Component using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    ```typescript theme={null}
    const messageListConfiguration = new MessageListConfiguration({
        templates: templates,
    });

    <CometChatMessages
      user={chatUser} 
      messageListConfiguration={messageListConfiguration} 
    />
    ```
  </Tab>

  <Tab title="JavaScript">
    ```javascript theme={null}
    const messageListConfiguration = new MessageListConfiguration({
        templates: templates,
    });

    <CometChatMessages
      user={chatUser}
      messageListConfiguration={messageListConfiguration}
    />
    ```
  </Tab>
</Tabs>

#### HeaderView

The `headerView` method of MessageTemplate allows you to add custom views to the header of your message bubbles. In the example below, we will add a custom header view of every text message in the MessageList.

**Default**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/lqGH-Bgiq2mgS9m9/images/bfd0876b-message_template_header_view_default_web_screens-9b1184146cd7eece15d2e290cd8b4f09.png?fit=max&auto=format&n=lqGH-Bgiq2mgS9m9&q=85&s=3c71dbd5fdcd41996e792f087d5ca893" width="3600" height="2400" data-path="images/bfd0876b-message_template_header_view_default_web_screens-9b1184146cd7eece15d2e290cd8b4f09.png" />
</Frame>

**Custom**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/_oiGBuX1qG3S8Eo5/images/63b5d52b-message_template_header_view_custom_web_screens-bafaad5ddc9b026dbd5ada89f047b14a.png?fit=max&auto=format&n=_oiGBuX1qG3S8Eo5&q=85&s=c5a1bd43364088a1ec159f36a90b20fd" width="3600" height="2400" data-path="images/63b5d52b-message_template_header_view_custom_web_screens-bafaad5ddc9b026dbd5ada89f047b14a.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CustomMessageTemplate.tsx

    ```typescript theme={null}
    import React from "react";
    import { CometChatMessages, CometChatUIKit , CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = React.useState<CometChatMessageTemplate[]>([]);
        const [chatUser, setChatUser] = React.useState<CometChat.User>();
        React.useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            })

           let definedTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
           const template =  definedTemplates.map((templates)=>{
                if (templates.type === "text" && templates.category === CometChatUIKitConstants.MessageCategory.message) {
                    templates.headerView = (message:CometChat.BaseMessage) => getHeaderView(message)
                    return templates;
                }
                return templates
            })
            setTemplates(template);
        }, []);

          const getHeaderView = (message: CometChat.BaseMessage) => {
            return(
                <cometchat-avatar image="custom avatar"/>
            )
          }
          const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
          });

        return (
            <div style={{height:"100%", width:"100%"}}>
            <CometChatMessages
                user={chatUser}
                messageListConfiguration={messageListConfiguration}
            />
            </div>
        )
    }

    export { CustomMessageTemplate };
    ```
  </Tab>

  <Tab title="JavaScript">
    CustomMessageTemplate.jsx

    ```javascript theme={null}
    import React, { useEffect, useState } from "react";
    import { CometChatMessages, CometChatUIKit, CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = useState([]);
        const [chatUser, setChatUser] = useState(null);

        useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            });

            const fetchTemplates = async () => {
                const definedTemplates = await CometChatUIKit.getDataSource().getAllMessageTemplates();
                const updatedTemplates = definedTemplates.map((template) => {
                    if (template.type === "text" && template.category === CometChatUIKitConstants.MessageCategory.message) {
                        template.headerView = (message) => getHeaderView(message);
                    }
                    return template;
                });
                setTemplates(updatedTemplates);
            };

            fetchTemplates();
        }, []);

        const getHeaderView = (message) => {
            return (
                <cometchat-avatar image="custom avatar" />
            );
        };

        const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
        });

        return (
            <div style={{ height: "100%", width: "100%" }}>
                <CometChatMessages
                    user={chatUser}
                    messageListConfiguration={messageListConfiguration}
                />
            </div>
        );
    };

    export { CustomMessageTemplate };
    ```
  </Tab>
</Tabs>

#### Contentview

The `contentview` method of MessageTemplate allows you to add a custom view to the content of your message bubbles. In the example below, we will add a custom layout to the content view of every text message in the MessageList.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/pIKiBC-6hdnqY01x/images/532b9ddc-message_template_content_view_custom_web_screens-f53ef342d2568cc56488c6484b048741.png?fit=max&auto=format&n=pIKiBC-6hdnqY01x&q=85&s=67675bc4cc00ef0dd7a47107fbb101ef" width="3600" height="2400" data-path="images/532b9ddc-message_template_content_view_custom_web_screens-f53ef342d2568cc56488c6484b048741.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CustomMessageTemplate.tsx

    ```typescript theme={null}
    import React from "react";
    import { CometChatMessages, CometChatUIKit , CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import rocketIcon from "./rocket.gif";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = React.useState<CometChatMessageTemplate[]>([]);
        const [chatUser, setChatUser] = React.useState<CometChat.User>();
        React.useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            })

            let definedTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
            const CUSTOM_MESSAGE_TYPE = "nudge";
            let customMessageTemplate = new CometChatMessageTemplate({
                type: CUSTOM_MESSAGE_TYPE,
                category: CometChatUIKitConstants.MessageCategory.custom,
                contentView: (message: CometChat.BaseMessage) => getContentView(message),
            });
            definedTemplates.push(customMessageTemplate);
            setTemplates(definedTemplates);
        }, []);

        const getContentView = (message: CometChat.BaseMessage) => {
            return (
                <div style={{width: "100px", height: "100px", display: "flex"}}>
                    <img src={rocketIcon} alt="gif" />
                </div>
            )
        }
        const getMessageRequestBuilder = () => {
            let categories = CometChatUIKit.getDataSource().getAllMessageCategories();
            categories.push(CometChatUIKitConstants.MessageCategory.custom);
            let types = CometChatUIKit.getDataSource().getAllMessageTypes();
            types.push(CUSTOM_MESSAGE_TYPE);
            return new CometChat.MessagesRequestBuilder().setCategories(categories).setTypes(types).hideReplies(true).setLimit(30);
        }
        const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
            messagesRequestBuilder: getMessageRequestBuilder()
        });

        return (
            <div style={{height:"100%", width:"100%"}}>
            <CometChatMessages
                user={chatUser}
                messageListConfiguration={messageListConfiguration}
            />
            </div>
        )
    }

    export { CustomMessageTemplate };
    ```
  </Tab>

  <Tab title="JavaScript">
    CustomMessageTemplate.jsx

    ```javascript theme={null}
    import React, { useEffect, useState } from "react";
    import { CometChatMessages, CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import rocketIcon from "./rocket.gif";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = useState([]);
        const [chatUser, setChatUser] = useState(null);

        useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            });

            let definedTemplates = CometChat.getDataSource().getAllMessageTemplates();
            const CUSTOM_MESSAGE_TYPE = "nudge";
            let customMessageTemplate = new CometChatMessageTemplate({
                type: CUSTOM_MESSAGE_TYPE,
                category: CometChatUIKitConstants.MessageCategory.custom,
                contentView: (message) => getContentView(message),
            });
            definedTemplates.push(customMessageTemplate);
            setTemplates(definedTemplates);
        }, []);

        const getContentView = (message) => {
            return (
                <div style={{ width: "100px", height: "100px", display: "flex" }}>
                    <img src={rocketIcon} alt="gif" />
                </div>
            );
        };

        const getMessageRequestBuilder = () => {
            let categories = CometChat.getDataSource().getAllMessageCategories();
            categories.push(CometChatUIKitConstants.MessageCategory.custom);
            let types = CometChat.getDataSource().getAllMessageTypes();
            types.push("nudge");
            return new CometChat.MessagesRequestBuilder().setCategories(categories).setTypes(types).hideReplies(true).setLimit(30);
        };

        const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
            messagesRequestBuilder: getMessageRequestBuilder()
        });

        return (
            <div style={{ height: "100%", width: "100%" }}>
                <CometChatMessages
                    user={chatUser}
                    messageListConfiguration={messageListConfiguration}
                />
            </div>
        );
    };

    export { CustomMessageTemplate };
    ```
  </Tab>
</Tabs>

#### BottomView

The `bottomView` method of MessageTemplate allows you to add a custom button view to your message bubbles. In the example below, we will add a custom bottom view to every text message in the MessageList.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/GrDbzzq1LLfv-sgw/images/861d8201-message_template_bottom_view_custom_web_screens-0ece44f31e48fc158b67327a3bfd047a.png?fit=max&auto=format&n=GrDbzzq1LLfv-sgw&q=85&s=56de7350bf7c1dae35139ee478abd864" width="3600" height="2400" data-path="images/861d8201-message_template_bottom_view_custom_web_screens-0ece44f31e48fc158b67327a3bfd047a.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CustomMessageTemplate.tsx

    ```typescript theme={null}
    import React from "react";
    import { CometChatMessages, CometChatUIKit , CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration, TextBubbleStyle } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = React.useState<CometChatMessageTemplate[]>([]);
        const [chatUser, setChatUser] = React.useState<CometChat.User>();

        React.useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            })

           let definedTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
           const template =  definedTemplates.map((templates)=>{
                if (templates.type === "text" && templates.category === CometChatUIKitConstants.MessageCategory.message) {
                    templates.bottomView = (message:CometChat.BaseMessage) => getBottomView(message)
                    return templates;
                }
                return templates
            })
            setTemplates(template);
        }, []);

        const getBottomView = (message: CometChat.BaseMessage) => {
            if (message instanceof CometChat.TextMessage) {
                const textStyle = new TextBubbleStyle({
                    width: "100",
                    height: "10px",
                    borderRadius: "8px",
                    background: "#e3d7fa",
                });
                return (
                    <cometchat-text-bubble text={message.getText()} textStyle={JSON.stringify(textStyle)} />
                );
            } else {
                // Handle other message types
                return null;
            }
        };
        const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
        });

        return (
            <div style={{height:"100%", width:"100%"}}>
            <CometChatMessages
                user={chatUser}
                messageListConfiguration={messageListConfiguration}
            />
            </div>
        )
    }

    export { CustomMessageTemplate };
    ```
  </Tab>

  <Tab title="JavaScript">
    CustomMessageTemplate.jsx

    ```javascript theme={null}
    import React, { useEffect, useState } from "react";
    import { CometChatMessages, CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration, TextBubbleStyle } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = useState([]);
        const [chatUser, setChatUser] = useState(null);

        useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            });

            let definedTemplates = CometChat.getDataSource().getAllMessageTemplates();
            const template = definedTemplates.map((template) => {
                if (template.type === "text" && template.category === CometChatUIKitConstants.MessageCategory.message) {
                    template.bottomView = (message) => getBottomView(message);
                    return template;
                }
                return template;
            });
            setTemplates(template);
        }, []);

        const getBottomView = (message) => {
            if (message instanceof CometChat.TextMessage) {
                const textStyle = new TextBubbleStyle({
                    width: "100",
                    height: "10px",
                    borderRadius: "8px",
                    background: "#e3d7fa",
                });
                return (
                    <cometchat-text-bubble text={message.getText()} textStyle={JSON.stringify(textStyle)} />
                );
            } else {
                // Handle other message types
                return null;
            }
        };

        const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
        });

        return (
            <div style={{ height: "100%", width: "100%" }}>
                <CometChatMessages
                    user={chatUser}
                    messageListConfiguration={messageListConfiguration}
                />
            </div>
        );
    };

    export { CustomMessageTemplate };
    ```
  </Tab>
</Tabs>

#### FooterView

The `footerView` method of MessageTemplate allows you to add a footer view to your message bubbles. In the example below, we will add a custom footer view to every text message in the MessageList.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/qrEt0CwYkpwR_jD-/images/d87ea225-message_template_footer_view_custom_web_screens-eb7bc4c1e190102474bbb42c5bb0b0cc.png?fit=max&auto=format&n=qrEt0CwYkpwR_jD-&q=85&s=7165c66b49b337dc53ce2dbe0a83909d" width="3600" height="2400" data-path="images/d87ea225-message_template_footer_view_custom_web_screens-eb7bc4c1e190102474bbb42c5bb0b0cc.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CustomMessageTemplate.tsx

    ```typescript theme={null}
    import React from "react";
    import { CometChatMessages, CometChatUIKit , CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = React.useState<CometChatMessageTemplate[]>([]);
        const [chatUser, setChatUser] = React.useState<CometChat.User>();

        React.useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            })

           let definedTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
           const template =  definedTemplates.map((templates)=>{
                if (templates.type === "text" && templates.category === CometChatUIKitConstants.MessageCategory.message) {
                    templates.footerView = (message:CometChat.BaseMessage) => getFooterView(message)
                    return templates;
                }
                return templates
            })
            setTemplates(template);
        }, [])

        React.useEffect(() => {

        }, []);

          const getFooterView = (message: CometChat.BaseMessage) => {
            return(
                <cometchat-avatar image="custom avatar"/>
            )
          }
          const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
          });

        return (
            <div style={{height:"100%", width:"100%"}}>
            <CometChatMessages
                user={chatUser}
                messageListConfiguration={messageListConfiguration}
            />
            </div>
        )
    }

    export { CustomMessageTemplate };
    ```
  </Tab>

  <Tab title="JavaScript">
    CustomMessageTemplate.jsx

    ```javascript theme={null}
    import React, { useState, useEffect } from "react";
    import { CometChatMessages, CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = useState([]);
        const [chatUser, setChatUser] = useState(null);

        useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            });

            let definedTemplates = CometChat.getDataSource().getAllMessageTemplates();
            const template = definedTemplates.map((template) => {
                if (template.type === "text" && template.category === CometChatUIKitConstants.MessageCategory.message) {
                    template.footerView = (message) => getFooterView(message);
                    return template;
                }
                return template;
            });
            setTemplates(template);
        }, []);

        const getFooterView = (message) => {
            return (
                <cometchat-avatar image="custom avatar" />
            );
        };

        const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
        });

        return (
            <div style={{ height: "100%", width: "100%" }}>
                <CometChatMessages
                    user={chatUser}
                    messageListConfiguration={messageListConfiguration}
                />
            </div>
        );
    };

    export { CustomMessageTemplate };
    ```
  </Tab>
</Tabs>

#### BubbleView

The `bubbleView` method of MessageTemplate allows you to add a bubble view to your message bubbles. In the example below, we will add a custom bubble view to the text message in the MessageList.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/THlknidvlbNx5AzI/images/ac20e2f6-message_template_bubble_view_custom_web_screens-68f7748d8215acee6ea475b43716d520.png?fit=max&auto=format&n=THlknidvlbNx5AzI&q=85&s=dc0985d4c684c0c2853a1e82db8bc391" width="3600" height="2400" data-path="images/ac20e2f6-message_template_bubble_view_custom_web_screens-68f7748d8215acee6ea475b43716d520.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CustomMessageTemplate.tsx

    ```typescript theme={null}
    import React from "react";
    import { CometChatMessages, CometChatUIKit , CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration, TextBubbleStyle } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = React.useState<CometChatMessageTemplate[]>([]);
        const [chatUser, setChatUser] = React.useState<CometChat.User>();

        React.useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            })

           let definedTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
           const template =  definedTemplates.map((templates)=>{
                if (templates.type === "text" && templates.category === CometChatUIKitConstants.MessageCategory.message) {
                    templates.bubbleView = (message:CometChat.BaseMessage) => getBubbleView(message)
                    return templates;
                }
                return templates
            })
            setTemplates(template);
        }, [])

        const getBubbleView = (message: CometChat.BaseMessage) => {
            if (message instanceof CometChat.TextMessage) {
                const textStyle = new TextBubbleStyle({
                    width: "100",
                    height: "20px",
                    borderRadius: "8px",
                    background: "#e3d7fa",
                });

                return (
                    <cometchat-text-bubble text={message.getText()} textStyle={JSON.stringify(textStyle)} />
                );
            }
        }
        const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
          });

        return (
            <div style={{height:"100%", width:"100%"}}>
            <CometChatMessages
                user={chatUser}
                messageListConfiguration={messageListConfiguration}
            />
            </div>
        )
    }

    export { CustomMessageTemplate };
    ```
  </Tab>

  <Tab title="JavaScript">
    CustomMessageTemplate.jsx

    ```javascript theme={null}
    import React, { useState, useEffect } from "react";
    import { CometChatMessages, CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration, TextBubbleStyle } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = useState([]);
        const [chatUser, setChatUser] = useState(null);

        useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            });

            let definedTemplates = CometChat.getDataSource().getAllMessageTemplates();
            const template = definedTemplates.map((template) => {
                if (template.type === "text" && template.category === CometChatUIKitConstants.MessageCategory.message) {
                    template.bubbleView = (message) => getBubbleView(message);
                    return template;
                }
                return template;
            });
            setTemplates(template);
        }, []);

        const getBubbleView = (message) => {
            if (message instanceof CometChat.TextMessage) {
                const textStyle = new TextBubbleStyle({
                    width: "100",
                    height: "20px",
                    borderRadius: "8px",
                    background: "#e3d7fa",
                });

                return (
                    <cometchat-text-bubble text={message.getText()} textStyle={JSON.stringify(textStyle)} />
                );
            }
        };

        const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
        });

        return (
            <div style={{ height: "100%", width: "100%" }}>
                <CometChatMessages
                    user={chatUser}
                    messageListConfiguration={messageListConfiguration}
                />
            </div>
        );
    };

    export { CustomMessageTemplate };
    ```
  </Tab>
</Tabs>

#### StatusInfoView

The `statusInfoView` method of MessageTemplate allows you to add a status info view to your message bubbles. In the example below, we will add a custom status info view to every text message in the MessageList.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/avBd8wan4jblx26s/images/26cf560b-message_template_status_info_view_web_screens-39132c39da71b1a77b2a8511a493e994.png?fit=max&auto=format&n=avBd8wan4jblx26s&q=85&s=042559838cbf319af3d08fc6f36c5a8e" width="3600" height="2400" data-path="images/26cf560b-message_template_status_info_view_web_screens-39132c39da71b1a77b2a8511a493e994.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CustomMessageTemplate.tsx

    ```typescript theme={null}
    import React from "react";
    import { CometChatMessages, CometChatUIKit, CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration, TextBubbleStyle } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = React.useState<CometChatMessageTemplate[]>([]);
        const [chatUser, setChatUser] = React.useState<CometChat.User>();

        React.useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            })

            let definedTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
            const template = definedTemplates.map((templates) => {
                if (templates.type === "text" && templates.category === CometChatUIKitConstants.MessageCategory.message) {
                    templates.statusInfoView = (message: CometChat.BaseMessage) => getStatusInfo(message)
                    return templates;
                }
                return templates
            })
            setTemplates(template);
        }, []);

        const getStatusInfo = (message: CometChat.BaseMessage) => {
            if (message instanceof CometChat.TextMessage) {
                const timestamp = message.getDeliveredAt();
                const date = new Date(timestamp * 1000);
                const hours = date.getHours();
                const minutes = date.getMinutes();
                const period = hours >= 12 ? 'PM' : 'AM';
                const formattedHours = hours % 12 || 12;
                const formattedMinutes = minutes < 10 ? '0' + minutes : minutes;
                const formattedTime = `${formattedHours}:${formattedMinutes} ${period}`;
                console.log(formattedTime);


                return (
                    <div
                        style={{
                            font: '10px Arial, sans-serif',
                            color: '#cccccc',
                            textAlign: 'left',
                            padding: '10px'
                        }}>
                        {formattedTime}
                    </div>
                );
            } else {
                // Handle other message types
                return null;
            }
        };
        const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
        });

        return (
            <div style={{ height: "100%", width: "100%" }}>
                <CometChatMessages
                    user={chatUser}
                    messageListConfiguration={messageListConfiguration}
                />
            </div>
        )
    }

    export { CustomMessageTemplate };
    ```
  </Tab>

  <Tab title="JavaScript">
    CustomMessageTemplate.jsx

    ```javascript theme={null}
    import React, { useState, useEffect } from "react";
    import { CometChatMessages, CometChatUIKit, CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = useState([]);
        const [chatUser, setChatUser] = useState();

        useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            })

            let definedTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
            const template = definedTemplates.map((templates) => {
                if (templates.type === "text" && templates.category === CometChatUIKitConstants.MessageCategory.message) {
                    templates.statusInfoView = (message) => getStatusInfo(message)
                    return templates;
                }
                return templates
            })
            setTemplates(template);
        }, []);

        const getStatusInfo = (message) => {
            if (message instanceof CometChat.TextMessage) {
                const timestamp = message.getDeliveredAt();
                const date = new Date(timestamp * 1000);
                const hours = date.getHours();
                const minutes = date.getMinutes();
                const period = hours >= 12 ? 'PM' : 'AM';
                const formattedHours = hours % 12 || 12;
                const formattedMinutes = minutes < 10 ? '0' + minutes : minutes;
                const formattedTime = `${formattedHours}:${formattedMinutes} ${period}`;

                return (
                    <div
                        style={{
                            font: '10px Arial, sans-serif',
                            color: '#cccccc',
                            textAlign: 'left',
                            padding: '10px'
                        }}>
                        {formattedTime}
                    </div>
                );
            } else {
                // Handle other message types
                return null;
            }
        };
        const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
        });

        return (
            <div style={{ height: "100%", width: "100%" }}>
                <CometChatMessages
                    user={chatUser}
                    messageListConfiguration={messageListConfiguration}
                />
            </div>
        )
    }

    export { CustomMessageTemplate };
    ```
  </Tab>
</Tabs>

#### Options

The `options` method in the MessageTemplate allows you to customize the options that appear in the action sheet when a message is long-pressed. By default, CometChat UI Kit provides a set of options like "Thread Reply", "Copy" ,"Edit", and "Delete".

However, if you wish to override or modify these options, you can use the `options` method and pass a list of `CometChatActionsIcon`. This list of options will replace the default set.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/tI1D0nyKUVcz2LEZ/images/c0a95c4d-message_template_options_web_screens-e1a23fcfe57771de050f09c68757b4f9.png?fit=max&auto=format&n=tI1D0nyKUVcz2LEZ&q=85&s=9ef3f9c5fbca82e7eaffaeeee21b7967" width="3600" height="2400" data-path="images/c0a95c4d-message_template_options_web_screens-e1a23fcfe57771de050f09c68757b4f9.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CustomMessageTemplate.tsx

    ```typescript theme={null}
    import React from "react";
    import { CometChatMessages, CometChatUIKit, CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration, CometChatTheme, CometChatActionsIcon } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import nudgeIcon from "./nudge.svg";

    const CustomMessageTemplate = () => {
      const [templates, setTemplates] = React.useState<CometChatMessageTemplate[]>([]);
      const [chatUser, setChatUser] = React.useState<CometChat.User>()
      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
          setChatUser(user);
        })

        let definedTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
        const template = definedTemplates.map((templates) => {
          if (templates.type === "text" && templates.category === CometChatUIKitConstants.MessageCategory.message) {
            templates.options = (loggedInUser: CometChat.User,
              message: CometChat.BaseMessage,
              theme: CometChatTheme,
              group?: CometChat.Group) => getCustomOptions(loggedInUser, message, theme, group)
            return templates;
          }
          return templates
        })
        setTemplates(template);
      }, []);

      const getCustomOptions = (
        loggedInUser: CometChat.User,
        message: CometChat.BaseMessage,
        theme: CometChatTheme,
        group?: CometChat.Group
      ) => {
        const defaultOptions: any =
          CometChatUIKit.getDataSource().getMessageOptions(
            loggedInUser,
            message,
            theme,
            group
          );
        const myView: any = new CometChatActionsIcon({
          id: "1",
          title: "refresh",
          iconURL: nudgeIcon,
          iconTint: "#b18cfa",
          onClick: () => console.log("custom on click"),
        });
        defaultOptions.push(myView);
        return defaultOptions;
      };
      const messageListConfiguration = new MessageListConfiguration({
        templates: templates,
      });
      return (
        <div style={{ height: "100%", width: "100%" }}>
          <CometChatMessages
            user={chatUser}
            messageListConfiguration={messageListConfiguration}
          />
        </div>
      )
    }

    export { CustomMessageTemplate };
    ```
  </Tab>

  <Tab title="JavaScript">
    CustomMessageTemplate.jsx

    ```javascript theme={null}
    import React, { useState, useEffect } from "react";
    import {
      CometChatMessages,
      CometChatUIKitConstants,
      MessageListConfiguration,
      CometChatActionsIcon,
    } from "@cometchat/chat-uikit-react";
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import nudgeIcon from "./nudge.svg";

    const CustomMessageTemplate = () => {
      const [templates, setTemplates] = useState([]);
      const [chatUser, setChatUser] = useState(null);

      useEffect(() => {
        CometChat.getUser("uid").then((user) => {
          setChatUser(user);
        });

        let definedTemplates = CometChat.getDataSource().getAllMessageTemplates();
        const template = definedTemplates.map((template) => {
          if (
            template.type === "text" &&
            template.category === CometChatUIKitConstants.MessageCategory.message
          ) {
            template.options = (loggedInUser, message, theme, group) =>
              getCustomOptions(loggedInUser, message, theme, group);
            return template;
          }
          return template;
        });
        setTemplates(template);
      }, []);

      const getCustomOptions = (loggedInUser, message, theme, group) => {
        const defaultOptions = CometChat.getDataSource().getMessageOptions(
          loggedInUser,
          message,
          theme,
          group
        );
        const myView = new CometChatActionsIcon({
          id: "1",
          title: "refresh",
          iconURL: nudgeIcon,
          iconTint: "#b18cfa",
          onClick: () => console.log("custom on click"),
        });
        defaultOptions.push(myView);
        return defaultOptions;
      };

      const messageListConfiguration = new MessageListConfiguration({
        templates: templates,
      });

      return (
        <div style={{ height: "100%", width: "100%" }}>
          <CometChatMessages
            user={chatUser}
            messageListConfiguration={messageListConfiguration}
          />
        </div>
      );
    };

    export { CustomMessageTemplate };
    ```
  </Tab>
</Tabs>

### New Templates

You can create an entirely new template for custom messages is one of the powerful features of CometChat's MessageTemplate.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Q-VZaihy61fy3D_G/images/1d4fb617-message_template_new_template_web_screens-b3c8ae39e5c1436dfd58cffe7d19bcd5.png?fit=max&auto=format&n=Q-VZaihy61fy3D_G&q=85&s=7c68c1daa12fcc88563a47c45f5e28e3" width="3600" height="2400" data-path="images/1d4fb617-message_template_new_template_web_screens-b3c8ae39e5c1436dfd58cffe7d19bcd5.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    CustomMessageTemplate.tsx

    ```typescript theme={null}
    import React from "react";
    import { CometChatMessages, CometChatUIKit,IconStyle , CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration, MessageComposerConfiguration, CometChatUIKitUtility} from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import rocketIcon from "./rocket.gif";
    import nudgeIcon from "./nudgeIcon.svg";


    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = React.useState<CometChatMessageTemplate[]>([]);
        const [chatUser, setChatUser] = React.useState<CometChat.User>()
        React.useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            })
        }, [])

        const CUSTOM_MESSAGE_TYPE = "nudge";

        React.useEffect(() => {
            let definedTemplates = CometChatUIKit.getDataSource().getAllMessageTemplates();
            let customMessageTemplate = new CometChatMessageTemplate({
                type: CUSTOM_MESSAGE_TYPE,
                category: CometChatUIKitConstants.MessageCategory.custom,
                contentView: (message: CometChat.BaseMessage) => getContentView(message)
            });
            definedTemplates.push(customMessageTemplate);
            setTemplates(definedTemplates);

        }, []);



        const getContentView = (message: CometChat.BaseMessage) => {
            return (
                <div style={{width: "100px", height: "100px", display: "flex"}}>
                    <img src={rocketIcon} alt="gif" />
                </div>
            )
        }

        const getAuxiliaryView = () => {

            const iconStyle = new IconStyle({ iconTint:"#9415e8", width: "35px", height: "35px" });
            return (
                <cometchat-icon URL={nudgeIcon} iconStyle={JSON.stringify(iconStyle)} onClick={sendMessage}></cometchat-icon>
            )
        }

        const sendMessage = () => {

            let { receiverID, receiverType } = getReceiverDetails();
            let customData = {nudge: CUSTOM_MESSAGE_TYPE};

            const customMessage = new CometChat.CustomMessage(receiverID, receiverType, CUSTOM_MESSAGE_TYPE, customData);
            customMessage.setSentAt(CometChatUIKitUtility.getUnixTimestamp());
            customMessage.setMuid(CometChatUIKitUtility.ID());
            CometChatUIKit.sendCustomMessage(customMessage);
        }

        const getReceiverDetails = () => {

            if (chatUser?.getUid()) {
                return { receiverID: chatUser?.getUid(), receiverType: CometChatUIKitConstants.MessageReceiverType.user };

            }
            return {receiverID: "", receiverType: ""};
        }

        const getMessageRequestBuilder = () => {

            let categories = CometChatUIKit.getDataSource().getAllMessageCategories();
            categories.push(CometChatUIKitConstants.MessageCategory.custom);

            let types = CometChatUIKit.getDataSource().getAllMessageTypes();
            types.push(CUSTOM_MESSAGE_TYPE);

            return new CometChat.MessagesRequestBuilder().setCategories(categories).setTypes(types).hideReplies(true).setLimit(30);
        }

        const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
            messagesRequestBuilder: getMessageRequestBuilder()
        });

        const messageComposerConfiguration = new MessageComposerConfiguration({
            auxilaryButtonView: getAuxiliaryView
        });

        return (
            <div style={{height:"100%", width:"100%"}}>
            <CometChatMessages
                user={chatUser}
                messageListConfiguration={messageListConfiguration}
                messageComposerConfiguration={messageComposerConfiguration}
            />
            </div>
        )
    }

    export { CustomMessageTemplate };
    ```
  </Tab>

  <Tab title="JavaScript">
    CustomMessageTemplate.jsx

    ```javascript theme={null}
    import React, { useState, useEffect } from "react";
    import { CometChatMessages, CometChatUIKitConstants, CometChatMessageTemplate, MessageListConfiguration, MessageComposerConfiguration, CometChatUIKitUtility } from '@cometchat/chat-uikit-react';
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import rocketIcon from "./rocket.gif";
    import nudgeIcon from "./nudgeIcon.svg";

    const CustomMessageTemplate = () => {
        const [templates, setTemplates] = useState([]);
        const [chatUser, setChatUser] = useState(null);

        useEffect(() => {
            CometChat.getUser("uid").then((user) => {
                setChatUser(user);
            });
        }, []);

        const CUSTOM_MESSAGE_TYPE = "nudge";

        useEffect(() => {
            let definedTemplates = CometChat.getDataSource().getAllMessageTemplates();
            let customMessageTemplate = new CometChatMessageTemplate({
                type: CUSTOM_MESSAGE_TYPE,
                category: CometChatUIKitConstants.MessageCategory.custom,
                contentView: (message) => getContentView(message)
            });
            definedTemplates.push(customMessageTemplate);
            setTemplates(definedTemplates);
        }, []);

        const getContentView = (message) => {
            return (
                <div style={{ width: "100px", height: "100px", display: "flex" }}>
                    <img src={rocketIcon} alt="gif" />
                </div>
            );
        };

        const getAuxiliaryView = () => {
            const sendMessage = () => {
                let { receiverID, receiverType } = getReceiverDetails();
                let customData = { nudge: CUSTOM_MESSAGE_TYPE };
                const customMessage = new CometChat.CustomMessage(receiverID, receiverType, CUSTOM_MESSAGE_TYPE, customData);
                customMessage.setSentAt(CometChatUIKitUtility.getUnixTimestamp());
                customMessage.setMuid(CometChatUIKitUtility.ID());
                CometChat.sendCustomMessage(customMessage);
            };

            return (
                <cometchat-icon URL={nudgeIcon} iconStyle={{ iconTint: "#9415e8", width: "35px", height: "35px" }} onClick={sendMessage} />
            );
        };

        const getReceiverDetails = () => {
            if (chatUser?.getUid()) {
                return { receiverID: chatUser?.getUid(), receiverType: CometChatUIKitConstants.MessageReceiverType.user };
            }
            return { receiverID: "", receiverType: "" };
        };

        const getMessageRequestBuilder = () => {
            let categories = CometChat.getDataSource().getAllMessageCategories();
            categories.push(CometChatUIKitConstants.MessageCategory.custom);

            let types = CometChat.getDataSource().getAllMessageTypes();
            types.push(CUSTOM_MESSAGE_TYPE);

            return new CometChat.MessagesRequestBuilder().setCategories(categories).setTypes(types).hideReplies(true).setLimit(30);
        };

        const messageListConfiguration = new MessageListConfiguration({
            templates: templates,
            messagesRequestBuilder: getMessageRequestBuilder()
        });

        const messageComposerConfiguration = new MessageComposerConfiguration({
            auxilaryButtonView: getAuxiliaryView
        });

        return (
            <div style={{ height: "100%", width: "100%" }}>
                <CometChatMessages
                    user={chatUser}
                    messageListConfiguration={messageListConfiguration}
                    messageComposerConfiguration={messageComposerConfiguration}
                />
            </div>
        );
    };

    export { CustomMessageTemplate };
    ```
  </Tab>
</Tabs>
